[Leetcode]Two Sum

来源:互联网 发布:ios app新闻项目源码 编辑:程序博客网 时间:2024/06/04 19:47

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2

给定一个数组,找到其中两个数的index,这两个数相加等于目标值~ 可以用Hash Table做,如果num[i]不在哈希表里,则把target - num[i]写入哈希表里,如果num[i]在哈希表里,则直接返回(dict[num[i]], i + 1)~时间复杂度,空间复杂度都为O(N)~

class Solution:    # @return a tuple, (index1, index2)    def twoSum(self, num, target):        if num is None or len(num) < 2: return None        dict = {}        for i in xrange(len(num)):            if num[i] not in dict:                dict[target - num[i]] = i + 1            else:                return (dict[num[i]], i + 1)


如果题目要求返回的是这两个数的数值,而不是index的话,还有另外一种解法,用两个指针夹逼~先把数组排序(num.sort()),如果左右两个指针所指的数等于target,就返回,如果大于target,左端指针右移的话两数之和只会更大,所以右端指针向左移,反之亦然~算法时间复杂度为O(nlogn + n) = O(nlogn)

0 0
原创粉丝点击